import { Injectable, NgModule } from '@angular/core';
import { FormBuilder, FormsModule, ReactiveFormsModule } from '@angular/forms';

class NgxTypedFormBuilderService {
    constructor(fb) {
        this.fb = fb;
    }
    control(formState, validatorOrOpts, asyncValidator) {
        return this.fb.control(formState, validatorOrOpts, asyncValidator);
    }
    group(controlsConfig, options) {
        return this.fb.group(controlsConfig, options);
    }
    array(controlsConfig, validatorOrOpts, asyncValidator) {
        return this.fb.array(controlsConfig, validatorOrOpts, asyncValidator);
    }
}
NgxTypedFormBuilderService.decorators = [
    { type: Injectable }
];
NgxTypedFormBuilderService.ctorParameters = () => [
    { type: FormBuilder }
];
// let x: NgxTypedFormBuilderService
// const z = x.group<{ a: string, b: TypedFormArray<string>, bb: TypedFormArray<TypedFormArray<string>>, c: TypedFormGroup<{ cc1: TypedFormGroup<{ ccc1: TypedFormGroup<{ cccc1: string, cccc2: number }> }>, cc2: number }> }>({ a: [], b: [], c: [] })
// z.value
// z.controls.b.value
// z.controls.bb.value
// z.controls.c.value.cc1.ccc1.cccc1
// z.controls.c.value

class NgxTypedFormBuilderModule {
}
NgxTypedFormBuilderModule.decorators = [
    { type: NgModule, args: [{
                imports: [
                    FormsModule,
                    ReactiveFormsModule
                ],
                providers: [
                    NgxTypedFormBuilderService
                ],
            },] }
];

/*
 * Public API Surface of ngx-typed-form-builder
 */

/**
 * Generated bundle index. Do not edit.
 */

export { NgxTypedFormBuilderModule, NgxTypedFormBuilderService };
//# sourceMappingURL=ngx-typed-form-builder.js.map
